#pragma once

class CyclicRedundancyChecker
{
public:

    void createTable()
    {
        unsigned long c{0};
        for (int n = 0; n < 256; n++)
        {
            c = (unsigned long) n;
            for (int k = 0; k < 8; k++)
            {
                if (c & 1)
                {
                    c = 0xedb88320L ^ (c >> 1);
                }
                else
                {
                    c = c >> 1;
                }
            }
            mTable[n] = c;
        }
        mTableComputed = true;
        mTableComputed = 1;
    }

    unsigned long updateCrc(unsigned long crc, unsigned char *buf, int len)
    {
        unsigned long c = crc;
        if (!mTableComputed)
        {
            createTable();
        }
        for (int n = 0; n < len; n++)
        {
            c = mTable[(c ^ buf[n]) & 0xff] ^ (c >> 8);
        }
        return c;
    }

    unsigned long doCrc(unsigned char *buf, int len)
    {
        return updateCrc(0xffffffffL, buf, len) ^ 0xffffffffL;
    }

private:
    bool mTableComputed{false};
    unsigned long mTable[256];
};
